#include "ConstantsCL.h"


struct CodeEntry
{
	uint code;
	uint length;
};


__kernel void compress(	const __global uchar* data, 
						uint size, 
						const __global struct CodeEntry* codeBook, 
						__global uchar* compressed,
						__global ulong* chunkLength)
{
	// DIDN'T WORK... WHY??
	// __local uint cbCode[CODEBOOKSIZE];
	// __local uint cbLength[CODEBOOKSIZE];
	
	// Make a local copy of the codebook.
	//if (GIDX < CODEBOOKSIZE)
	//{
//		cbCode[GIDX] 	= codeBook[GIDX].code;
//		cbLength[GIDX] 	= codeBook[GIDX].length;
//	}

	//event_t event = async_work_group_copy(localCodeBook, codeBook, CODEBOOKSIZE, 0);
	//wait_group_events(1, &event);
	
	// Synch all threads.
	//barrier(CLK_LOCAL_MEM_FENCE);

	chunkLength[GIDX] = 0;
	
	// Every Thread compresses 1024 bytes of data.
	uint localOffset = GIDX * BYTESPERTHREAD;
	uint compressedOffset = 0;
	uint compressedStart = localOffset * 2;
	
	// If there is nothing to do for this thread, return.
	if (localOffset > size)
		return;
	
	// Calculate how many bytes to render.
	uint countInterval = BYTESPERTHREAD;
	if (localOffset + BYTESPERTHREAD >= size)
		countInterval = size - localOffset;

	// Compress the data chunk.
	uint current = 0;
	uint length = 0;

	// Some dword loop values.
	uint dwords = countInterval / 4;
	uint clipping = countInterval % 4;
	uint dwordOffset = localOffset / 4;
	const __global uint* dwordData = (const __global uint*)data;

	//chunkLength[GIDX] = countInterval;

	for (uint i = 0; i < dwords; i++)
	{
		// Load 4 bytes of data from source.
		uint currentDword = dwordData[dwordOffset + i];
		
		// Check all four bytes.
		#pragma unroll
		for (uint c = 0; c < 4; c++)
		{
			// Load next token.
			uchar token = currentDword & 0xFF;
			
			// Add compressed symbol to solution token.
			current |= (codeBook[token].code << length);
			length += codeBook[token].length;
//			current |= (cbCode[token] << length);
//			length += cbLength[token];
			
			// Check, if solution token is bigger than 1 byte.
			if (length >= 8)
			{
				// Store solution token.
				uchar pushByte = (uchar)(current & 0xFF);
				// Every compressed data chunk is 2048 bytes big. (Overflow protection)
				compressed[compressedStart + compressedOffset] = pushByte;
				compressedOffset++;
					
				// Update solution token.
				current >>= 8;
				length -= 8;
			}
			
			// Shift dword to read the next 8 bit token.
			currentDword >>= 8;
		}
	}
	
	for (uint i = 0; i < clipping; i++)
	{
		// Load 4 bytes of data from source.
		uchar token = data[dwords * 4 + localOffset + i];
		
		// Add compressed symbol to solution token.
		current |= (codeBook[token].code << length);
		length += codeBook[token].length;
			
		// Check, if solution token is bigger than 1 byte.
		if (length >= 8)
		{
			// Store solution token.
			uchar pushByte = (uchar)(current & 0xFF);
			
			// Every compressed data chunk is 2048 bytes big. (Overflow protection)
			compressed[compressedStart + compressedOffset] = pushByte;
			compressedOffset++;
				
			// Update solution token.
			current >>= 8;
			length -= 8;
		}
	}

	// Store clipping bits.
	if (length != 0)
	{
		compressed[compressedStart + compressedOffset] = current;
		//compressedOffset++;
	}
	
	// Store complete length of compressed chunk.
	chunkLength[GIDX] = compressedOffset * 8 + length;
}
