// Some useful constants for readability.
#define LOG2_WARP_SIZE 5U
#define WARP_SIZE (1U << LOG2_WARP_SIZE)
#define UINT_BITS 32
#define HISTOGRAM256_BIN_COUNT 256
#define PARTIAL_HISTOGRAM256_COUNT 240

// Tag for serializing parallel write access within a warp
// See "Histogram demo" from NVIDIA CUDA package for further information.
#define TAG_MASK ( (1U << (UINT_BITS - LOG2_WARP_SIZE)) - 1U )

//Momentarily 16, could get greater in future!
#define SHARED_MEMORY_BANKS 16

//Warps == subhistograms per threadblock
#define WARP_COUNT 6

//Threadblock size
#define HISTOGRAM256_THREADBLOCK_SIZE (WARP_COUNT * WARP_SIZE)

//Shared memory per threadblock
#define HISTOGRAM256_THREADBLOCK_MEMORY (WARP_COUNT * HISTOGRAM256_BIN_COUNT)

#define MERGE_THREADBLOCK_SIZE 256


#define GIDX 		get_global_id(0)
#define LIDX 		get_local_id(0)
#define WORKSIZEX	get_global_size(0)
#define LOCALSIZEX 	get_local_size(0)

#define CODEBOOKSIZE 	256
#define DWORDPERTHREAD	1024 //(1024*1024)
#define BYTESPERTHREAD (DWORDPERTHREAD*4)
#define LOCALWORKSIZE	16