#pragma once

#include <exception>
#include "conversion.h"

class AssertException : public std::exception
{
protected:
	std::string err;

	virtual const char* what() const throw()
	{
		return err.c_str();
	}

public:
	AssertException(std::string assertString)
		: err(assertString) {}
};

class InvalidFileException : public AssertException
{
public:
	InvalidFileException(std::string _filename)
		: AssertException(buildString("File invalid: %s", _filename)) {}
};

