#pragma once

#include <map>

#define NULL 0

struct HuffmanNode
{
	HuffmanNode* left;
	HuffmanNode* right;
	unsigned char letter;
	unsigned int frequency;

	HuffmanNode(unsigned int _frequency, unsigned char _letter)
		: frequency(_frequency), letter(_letter), left(NULL), right(NULL) {}

	HuffmanNode(HuffmanNode* _left, HuffmanNode* _right)
		: letter(NULL), left(_left), right(_right)
	{
		frequency = left->frequency + right->frequency;
	}

	~HuffmanNode()
	{
		if (left != NULL)
			delete left;
		if (right != NULL)
			delete right;
	}

};

typedef std::multimap<unsigned int, HuffmanNode*> NodeSet;

